<template>
  <form action="" @submit.prevent>
    <label>Neue Regel hinzufügen</label>
    <div class="input-group">
      <input type="text" class="rule-input" maxlength="1" v-model="lhs">
      <span>⟶</span>
      <input type="text" class="rule-input" v-model="rhs">
    </div>
    <button class="is-elevated" @click="addRule">Hinzufügen</button>
    <div v-if="error" class="error">
      {{ error }}
    </div>
  </form>
</template>

<script>

import {inject, ref} from "vue";

export default {
  name: "RuleForm",
  components: {
  },
  setup() {
    const lhs = ref("")
    const rhs = ref("")
    const error = ref("")
    const errorLeft = ref(false)
    const errorRight = ref(false)

    const toggleModal = inject('toggleModal')

    const column = inject('col')

    const addRule = () => {

      if(lhs.value == "" || rhs.value == "") {
        error.value = "Bitte füllen Sie beide Felder aus"
      } else if(lhs.value == lhs.value.toLowerCase()) {
        error.value = "Es sind nur Großbuchstaben erlaubt"
      } else if(containsRule({lhs: lhs.value, rhs: rhs.value})) {
        error.value = "Diese Regel ist bereits in der Spalte enthalten"
      } else {
        column.value.rules.push({
          lhs: lhs.value,
          rhs: rhs.value
        })
        toggleModal()

        if(column.value.state == 'error') {
          column.value.state = 'editing'
        }
      }

    }

    const containsRule = (rule) => {
      const index = column.value.rules.findIndex(r => r.lhs === rule.lhs && r.rhs === rule.rhs);
      return index > -1;
    }

    return {
      lhs,
      rhs,
      addRule,
      error
    }
  }
}
</script>

<style scoped>

</style>